/* This project developed by Eddie Matejowsky an Ozzie techi guru
 * for more details of chip hacking on 
 * http://www.eddiem.com/photo/printer/chipreset/resetchip.html
 * with his delphi source code. Thanks Eddie.
 * This software is under the GNU Public License (GPL)
 * Disclaimer: We are not responsible for any damage.
 * use at your own risk.
 * 
 * By Benoy George, benos@hotpop.com
 *
 * Cygwin Port was done by Volkan Sahin, vsahin@sbcglobal.net
 * If you use inverter as a buffer (simple npn transistor) between inkjet 
 * cartridge chip  and printer port then you need to define INVERTEDDATA 
 * To avoid timing problems while reading/writing chip, delays are increased.
 * Current Cygwin version needs port95nt.exe installation 
 * It can be downloaded from http://www.driverlinx.com/DownLoad/dnload.htm#Windows%2095/NT%20Port%20I/O%20Driver 
 * For more information on port access in Cygwin visit 
 * http://www.eeng.dcu.ie/~scaifer/win2k-dlportio-mingw/DLPORTIOandWIN2KandMinGW32.html  
 * 
 */

#include "chipset.h"
//#define INVERTEDDATA

int  main (int argc, char **argv) {
           int c,opt_arg;
           int digit_optind = 0;

   	   //ioperm(LPT,3,1);
   	   resetport();

           while (1) {
               int this_option_optind = optind ? optind : 1;
               int option_index = 0;
               static struct option long_options[] = {
                   {"blindreset", 0, 0,'b'},
                   {"data",   0, 0,'d'},
                   {"half_fill",  0, 0,'h'},
                   {"readchip",   0, 0,'r'},
                   {"repeatgetchip",0,0,0 },
                   {"resetport",  0, 0,'p'},
                   {"resetblack", 0, 0,'B'},
                   {"resetcolor", 0, 0,'C'},
                   {"savedata",   1, 0,'s'},
                   {"version",    0, 0,'v'},
                   {"writechip",  1, 0,'w'},
                   {"zerofirst",  1, 0,'z'},
                   {"makeempty",  1, 0,'e'},
                   {0,            0, 0, 0 }
               };

               c = getopt_long (argc, argv, "bdf:herpBCs:Svw:z:0",long_options, &option_index);
               if (c == -1)
                   break;

               switch (c) {
               case 0:
                   printf ("option %s", long_options[option_index].name);
                   if (optarg)
                       printf (" with arg %s", optarg);
                   printf ("\n");
                   break;

               case '0':
               case '1':
               case '2':
                   if (digit_optind != 0 && digit_optind != this_option_optind)
                     printf ("digits occur in two different argv-elements.\n");
                   digit_optind = this_option_optind;
                   printf ("option %c\n", c);
                   break;

              case 'b':
                   printf ("Blind reset chip...\n");
		   blindreset();
                   break;

               case 'C':
                   printf ("Reset colour...\n");
		   resetcolor();
                   break;

	       case 'd':
                   printf ("Read chip contents...\n");
		   ReadChip();  //Read chip contents and display
                   break;

	       case 'h':
		   usage();  
                   break;

	       case 'e':
                  // opt_arg = atoi(optarg);
                   printf ("Make Empty...\n");
		   fill_ff(0x0);  
                   break;

	       case 'r':
                   printf ("Read chip contents...\n");
		   ReadChip();  //Read chip contents and display
                   break;

               case 'p':
                   printf ("Port reset...\n");
		   resetport();  //send 0 to port for reset.
                   break;

               case 'B':
                   printf ("Reset black...\n");
		   resetblack(); 
                   break;

               case 's':
                   printf ("Save data...\n");
		   savedata(optarg);  
                   break;

               case 'w':
                   opt_arg = atoi(optarg);
                   printf ("Write chip...addr=%d\n", opt_arg);
// 		   writechip(opt_arg,&T60x[0]); 
                   break;
               case 'z':
                   printf ("Zero first %s byte...\n",optarg);
		   opt_arg = atoi(optarg); 
		   zerofirst(opt_arg); 
                   break;

	       case 'v':
                   printf ("Ep*Son cartridge chipset\nVersion 0.01\n");
                   break;

               case '?':
		   usage();
                   break;

               default:
		   usage();
                   //printf ("Reading chip... \n");
		   //ReadChip();
               }
           }

           if (optind < argc) {
               printf ("Unknown option or ARG elements:");
               while (optind < argc)
                   printf ("%s ", argv[optind++]);
               printf ("\n");
           }

	   if (argc==1) ReadChip();

	   printf("\n");
	   resetport();
	   //ioperm(LPT,3,0);
           exit (0);
}

int getchipbyte(){ 
	int i,shift;
	shift=0; // just to keep the compiler happy
	for (i=1;i<=8;i++){
//	   delay5us();
	   inb(PORT_IN);  // for a small wait
	   inb(PORT_IN);  // for a small wait
	   dataup();
	   clockup();
	   shift = shift >> 1;
#ifdef INVERTEDDATA
	   if ((inb(PORT_IN) & inmask) == 0) 
#else
	   if ((inb(PORT_IN) & inmask) != 0) 
#endif
		   shift=shift | 0x80;
//	   delay5us();
	   inb(PORT_IN);  // for a small wait
	   inb(PORT_IN);  // for a small wait
           delay500us();
	   clockdown();
	}
	return shift;
}

void repeatgetchip(){
  int i,j;
  printf("Continuous chip scan....");
  for (i=0;i<1000;i++){
    powerup();
    syncdown();
    delay500us();
    syncup();
    delay500us();
    sendnibble(i & 7);
    for (j=1;j<=32;j++)
	 chiparray[j]=getchipbyte();
    powerdown();
    delay500us();
    showdata(chiparray);
  }
}

void showdata(int *data_dump){
     int i;
     printf("MemAdd:Data..\n  0000:");
     for (i=0;i<= 31;i++) {
        if(i == 16){
     		printf("\n  00A0:");
        }
	printf("%02x ",data_dump[i]);
     }
     printf("\n");
}

void ReadChip(){
  int i=0, j, found=0;
  resetport();
  while (i<8){
    delay500us();
    powerup();
    syncdown();
    delay500us();
    syncup();
    delay500us();
    sendnibble(i & 7);
    for (j=0;j<=31;j++){
	chiparray[j]=getchipbyte();
        if (chiparray[j]!=0xff){
	   found=1; 
	   chipid=i; 
        }
//	printf("%02x ", i);
//	if (j==15) printf("\n");
    }
    i++;
//    printf("%d\n",i);
    syncdown();
    powerdown();
    delay500us();
    if (found == 1){ 
	  printf("Chip found with Address/ID: %d\n", chipid);
	  showdata(chiparray);
	  break;
    }
 }
 if (found != 1)  printf("Chip not found\n");
}

void resetinklevel(){
         ReadChip();
         powerup();
         syncdown();
         delay500us();
         syncup();
         delay500us();
         sendnibble(chipid | 0x08 );
         sendbyte(0x00);
         delay10Ms();
         syncdown();
         powerdown();
         ReadChip();
}

void zerofirst(unsigned int num){
	int i;
	if((num > 0) & (num <32)){
	        ReadChip();
	        powerup();
	        syncdown();
	        delay500us();
	        syncup();
	        delay500us();
	        sendnibble(chipid | 8 );
		for(i=0;i<=num;i++)
			sendbyte(0x00);
		delay10Ms();
	        syncdown();
	        powerdown();
	        ReadChip();
	}else{
		printf("Bytes starting from 1 to 32 only");
//		return -1;
	}
}
int fill_ff(int addr){
	int i;
        ReadChip();
        powerup();
        syncdown();
        delay500us();
        syncup();
        delay500us();
        sendnibble(addr | 8 );
	for(i=0;i<=31;i++)
		sendbyte(0xAA);
	delay10Ms();
        syncdown();
        powerdown();
        ReadChip();
}
void writechip(int addr, unsigned char *data)
{
  int i;

  ReadChip();
  powerup();
  syncdown();
  delay500us();
  syncup();
  delay500us();
  sendnibble(addr | 8 );
  for(i=0;i<32;i++) sendbyte(*data++);
  delay10Ms();
  syncdown();
  powerdown();
  ReadChip();
}//writechip
void Makeempty(){
         ReadChip();
         powerup();
         syncdown();
         delay500us();
         syncup();
         delay500us();
         sendnibble(chipid | 8 );
         sendbyte(0x63);
         delay10Ms();
         syncdown();
         powerdown();
         ReadChip();
}

void blindreset(){
	int i;
	powerup();
        for (i= 0;i<=7;i++){
         syncdown();
         delay500us();
         syncup();
         delay500us();
         sendnibble(i | 8 );
         sendbyte(0x00);
         delay10Ms();
         syncdown();
        }
        powerdown();
        ReadChip();
}

void resetblack(){
         powerup();
         wriswrite();
         syncdown();
         delay500us();
         syncup();
         delay500us();
         sendbyte(0x00);
         delay10Ms();
         syncdown();
         powerdown();
         wrisread();
         ReadChip();
}

void resetcolor(){
         powerup();
         wriswrite();
         syncdown();
         delay500us();
         syncup();
         delay500us();
         sendbyte(0x00);
         sendbyte(0x00);
         sendbyte(0x00);
         sendbyte(0x00);
         delay10Ms();
         syncdown();
         powerdown();
         wrisread();
         ReadChip();
}

static void usage(void){
    fprintf(stderr, ("Usage : chipset [-r] [-h] [-e] [-p] [-B] [-C] [-s filename] [-v] [-z 0-31]\n"));
    fprintf(stderr, (" -r, --readchip : Read and display chip data\n"));
    fprintf(stderr, (" -e, --empty : Make empty\n"));
    fprintf(stderr, (" -h, --help\n"));
    fprintf(stderr, (" -p, --resetport\n"));
    fprintf(stderr, (" -v, --version\n"));
    fprintf(stderr, (" -s, --savedata filename: Save chip data to file filename.\n"));
    fprintf(stderr, (" Developed by Eddie Matejowsky\n Ported to linux by Benoy George\n"));
    exit(-1);
}

void savedata(char* fname){
	int i;
	FILE *ftwrite;
	ftwrite = fopen (fname, "w");
	fprintf (ftwrite, "File generated by Chipset\n");
	fprintf(ftwrite,"MemAdd:Data..\n  0000:");
	for (i=0;i<= 31;i++) {
		if(i == 16) fprintf(ftwrite,"\n  00A0:");
		fprintf(ftwrite, "%02x ", getchipbyte());
	}
	fprintf (ftwrite,"\n");
	fclose (ftwrite);
}

